\
\ 11:13 12.10.2011 vum chu
\ 13:48 12.10.2013
\
\ ====================================================
\
\ ds1307 64x8 Serial Real-Time Clock
\
  marker =ds1307=
\
\ ====================================================
\  ds1307 operates in the regular mode (100kHz) only !
\ ====================================================
\
\ device address on i2c bus
\   $d0  constant twi.ds1307 old 
\ 0 $d0 2constant ds1307     new

 \
 \ ds1307 address map
 \
  $00  constant  RTC_SECONDS
  $01  constant  RTC_MINUTES
  $02  constant  RTC_HOURS
  $03  constant  RTC_DAY
  $04  constant  RTC_DATE
  $05  constant  RTC_MONTH
  $06  constant  RTC_YEAR
  $07  constant  RTC_CONTROL
  
  $08  constant  RTC_RAM
  $3f  constant  RTC_RAM_LAST
  
 \
 \    ds1307 control register 
 \ mask ................... bit

  $01  constant  BIT_RS0  \ 0
  $02  constant  BIT_RS1  \ 1
  $10  constant  BIT_SQWE \ 4
  $80  constant  BIT_OUT  \ 7

 \ clock halt bit==1, oscillator is disabled  
  $80  constant  clock_halt \ 7

 \ 1== 12-hour mode is selected
  $40  constant  12/24    \ 6

 \
  : rtc! ds1307 i2c-c! ;  \   <c>   <addr>  ds1307
  : rtc@ ds1307 i2c-c@ ;  \     <addr>  ds1307

\
  : rtc-cold
        clock_halt RTC_SECONDS rtc! \ osc disabled
        $00        RTC_HOURS   rtc! \ 24-hour mode
        BIT_OUT    RTC_CONTROL rtc! \ sqw/out pin==1, 1Hz rate
       ; 
\
  : rtc+
        RTC_SECONDS clock_halt invert
        over rtc@ and
        swap rtc!
       ; 
\
  : rtc-
        RTC_SECONDS clock_halt
        over rtc@ or
        swap rtc!
       ;

\ erase ds1307 memory
\ (fill all addresses with zero byte)

  : rtc-clear

        RTC_SECONDS ds1307
        i2c-open i2c-addr>       \ set ds1307  address pointer

       $00
        RTC_RAM_LAST 1+ 0
        do   dup
             twi.tx $28 twi.status?   \ send data byte 
        loop drop
     
        i2c-close 
       ;

\
\
\ ====================================================
\

  : >rtc  ds1307 i2c-[!] ; ( ramaddr cnt rtc.addr -- )

  : rtc>  ds1307 i2c-[@] ; ( ramaddr cnt rtc.addr -- )


\ ========================15:04 13.10.2013=====================

\  anew =clock=
 marker =clock=

   \ c!+ required
   : c!+ ( addr c -- addr+ ) over c! 1+ ;

  variable #stamp $20 allot	\ bufffor string


  : bcd>asci  ( bcd --- ascii ) $0f and [char] 0 + ;

  0        \ timekeeper registers
  1   --    <seconds>
  1   --    <minutes>
  1   --    <hours>
  1   --    <day>
  1   --    <date>
  1   --    <month>
  1   --    <year>
  1   --    <control>
  constant /rtc

  here dup /rtc dup allot 0 fill ( erase ) constant [rtc]

\      :
\    

  : digit   ( addr bcd -- addr+ )   bcd>asci c!+ ;
  : 2digit  ( addr c -- addr+ ) swap over 4 rshift digit swap digit ;
  : dot     ( addr  -- addr+ )  [char] . c!+ ;
  : colon   ( addr  -- addr+ )  $3a c!+  ;
  : century ( addr  -- addr+ )  [char] 2 c!+ [char] 0 c!+ ;
  : blank   ( addr  -- addr+ )  bl c!+ ;


\      
  : clock@
 
        [rtc]
        begin
         dup /rtc RTC_SECONDS  rtc>  \  

         dup <seconds>  c@
         RTC_SECONDS  rtc@ =         \    ?
        until

        #stamp 1+

        over <day>     c@  $7 and  digit dot
        over <date>    c@ $3f and 2digit dot
        over <month>   c@ $1f and 2digit dot
             century
        over <year>    c@ $ff and 2digit blank

        over <hours>   c@ $3f and 2digit colon
        over <minutes> c@ $ff and 2digit colon 
        over <seconds> c@ $3f and 2digit blank

        #stamp -
        #stamp c!
        drop
        ;
\
\ =============================================================
\

   : ?clock. 
        ." ds1307 control register = "
        RTC_CONTROL rtc@  .b ( .x ) cr       \
       ;

   : count  dup 1+ swap c@ ;

\
\
\  : rstr>lcd   ( ramaddr count -- )
\        over + swap
\        ?do i c@ lcd! loop
\        ;
\
\  : time?
\        lcd_clear clock@
\        #stamp  dup $0e rstr>lcd
\        1 0 lcd_xy! $0e + 8 rstr>lcd
\        ;


  : ?time. clock@ #stamp count 1 - type cr ;

\ =============================================================
\
\ occupies 621 cells flash